# -*- coding: utf8 -*-
from pyramid.view import view_config
from euhu.programs.sib import validate
from ringo_printtemplate.views import print_template

from ringo_bmasreport.reports.durchfuehrungsbericht import (
    filters, recipe, evaluate
)
from ringo_bmasreport.reports.sachbericht import prepare_result_for_print
from ringo_bmasreport.views import durchfuehrungsbericht as evaluate_view
from efa.lib.export_formats.xlsx_template import get_filename
from sib.model.participant import indicators, derive_indicators
from sib.model.participation import SIBParticipation as Participation
from sib.views.report_sachbericht import DummyData


@view_config(route_name='report_durchfuehrungsbericht',
             renderer='/durchfuehrungsbericht.mako')
def create_participation_report(request):
    result = evaluate_view(request, "sib", Participation, evaluate, recipe,
                           validate, derive_indicators, indicators, filters)
    return result


@view_config(route_name='report_print_durchfuehrungsbericht')
def print_report(request):
    result = evaluate_view(request, "sib", Participation, evaluate, recipe,
                           validate, derive_indicators, indicators, filters,
                           getvalidate=True)
    result = prepare_result_for_print(result, request)
    filename = get_filename("SIB", "ESF-Auswertung", True)
    return print_template(request, result,
                          DummyData(
                              "@sib:sib/static/"
                              "durchfuehrungsbericht_vorlage.odt",
                              name=filename))
